/*
 * K-scope
 * Copyright 2012-2013 RIKEN, Japan
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.riken.kscope.xcodeml.xml.gen;

import javax.xml.bind.annotation.XmlRegistry;

/**
 * This object contains factory methods for each Java content interface and Java
 * element interface generated in the jp.go.riken.ppa.xcodeml.xml.gen package.
 * <p>
 * An ObjectFactory allows you to programatically construct new instances of the
 * Java representation for XML content. The Java representation of XML content
 * can consist of schema derived interfaces and classes representing the binding
 * of schema type definitions, element declarations and model groups. Factory
 * methods for each of these are provided in this class.
 *
 */
/**
 * @author hira
 *
 */
@XmlRegistry
public class ObjectFactory {

    /**
     * Create a new ObjectFactory that can be used to create new instances of
     * schema derived classes for package: jp.go.riken.ppa.xcodeml.xml.gen
     *
     */
    public ObjectFactory() {
    }

    /**
     * Create an instance of {@link Declarations }
     *
     * @return      Declarations
     */
    public Declarations createDeclarations() {
        return new Declarations();
    }

    /**
     * Create an instance of {@link FbasicType }
     * @return FbasicType
     *
     */
    public FbasicType createFbasicType() {
        return new FbasicType();
    }

    /**
     * Create an instance of {@link FexitStatement }
     * @return FexitStatement
     *
     */
    public FexitStatement createFexitStatement() {
        return new FexitStatement();
    }

    /**
     * Create an instance of {@link DefModelExprList }
     * @return DefModelExprList
     *
     */
    public DefModelExprList createDefModelExprList() {
        return new DefModelExprList();
    }

    /**
     * Create an instance of {@link Var }
     * @return Var
     */
    public Var createVar() {
        return new Var();
    }

    /**
     * Create an instance of {@link LogGTExpr }
     * @return LogGTExpr
     */
    public LogGTExpr createLogGTExpr() {
        return new LogGTExpr();
    }

    /**
     * Create an instance of {@link FopenStatement }
     * @return FopenStatement
     */
    public FopenStatement createFopenStatement() {
        return new FopenStatement();
    }

    /**
     * Create an instance of {@link FifStatement }
     * @return FifStatement
     */
    public FifStatement createFifStatement() {
        return new FifStatement();
    }

    /**
     * Create an instance of {@link FallocateStatement }
     * @return FallocateStatement
     */
    public FallocateStatement createFallocateStatement() {
        return new FallocateStatement();
    }

    /**
     * Create an instance of {@link Id }
     * @return Id
     */
    public Id createId() {
        return new Id();
    }

    /**
     * Create an instance of {@link FcharacterRef }
     * @return FcharacterRef
     */
    public FcharacterRef createFcharacterRef() {
        return new FcharacterRef();
    }

    /**
     * Create an instance of {@link Else }
     * @return Else
     */
    public Else createElse() {
        return new Else();
    }

    /**
     * Create an instance of {@link FwhereStatement }
     * @return FwhereStatement
     */
    public FwhereStatement createFwhereStatement() {
        return new FwhereStatement();
    }

    /**
     * Create an instance of {@link LogNEQExpr }
     * @return LogNEQExpr
     */
    public LogNEQExpr createLogNEQExpr() {
        return new LogNEQExpr();
    }

    /**
     * Create an instance of {@link FpowerExpr }
     * @return FpowerExpr
     */
    public FpowerExpr createFpowerExpr() {
        return new FpowerExpr();
    }

    /**
     * Create an instance of {@link FselectCaseStatement }
     * @return FselectCaseStatement
     */
    public FselectCaseStatement createFselectCaseStatement() {
        return new FselectCaseStatement();
    }

    /**
     * Create an instance of {@link FdoLoop }
     * @return FdoLoop
     *
     */
    public FdoLoop createFdoLoop() {
        return new FdoLoop();
    }

    /**
     * Create an instance of {@link FdoStatement }
     * @return FdoStatement
     *
     */
    public FdoStatement createFdoStatement() {
        return new FdoStatement();
    }

    /**
     * Create an instance of {@link FstructType }
     * @return FstructType
     *
     */
    public FstructType createFstructType() {
        return new FstructType();
    }

    /**
     * Create an instance of {@link NamedValue }
     * @return NamedValue
     *
     */
    public NamedValue createNamedValue() {
        return new NamedValue();
    }

    /**
     * Create an instance of {@link Rename }
     * @return Rename
     *
     */
    public Rename createRename() {
        return new Rename();
    }

    /**
     * Create an instance of {@link Arguments }
     * @return Arguments
     **/
    public Arguments createArguments() {
        return new Arguments();
    }

    /**
     * Create an instance of {@link FprintStatement }
     * @return FprintStatement
     */
    public FprintStatement createFprintStatement() {
        return new FprintStatement();
    }

    /**
     * Create an instance of {@link FuseOnlyDecl }
     * @return FuseOnlyDecl
     */
    public FuseOnlyDecl createFuseOnlyDecl() {
        return new FuseOnlyDecl();
    }

    /**
     * Create an instance of {@link ExternDecl }
     * @return ExternDecl
     */
    public ExternDecl createExternDecl() {
        return new ExternDecl();
    }

    /**
     * Create an instance of {@link FequivalenceDecl }
     * @return FequivalenceDecl
     */
    public FequivalenceDecl createFequivalenceDecl() {
        return new FequivalenceDecl();
    }

    /**
     * Create an instance of {@link FarrayRef }
     * @return FarrayRef
     */
    public FarrayRef createFarrayRef() {
        return new FarrayRef();
    }

    /**
     * Create an instance of {@link VarDecl }
     * @return VarDecl
     */
    public VarDecl createVarDecl() {
        return new VarDecl();
    }

    /**
     * Create an instance of {@link ValueList }
     * @return ValueList
     */
    public ValueList createValueList() {
        return new ValueList();
    }

    /**
     * Create an instance of {@link FdeallocateStatement }
     * @return FdeallocateStatement
     */
    public FdeallocateStatement createFdeallocateStatement() {
        return new FdeallocateStatement();
    }

    /**
     * Create an instance of {@link LogEQExpr }
     * @return LogEQExpr
     */
    public LogEQExpr createLogEQExpr() {
        return new LogEQExpr();
    }

    /**
     * Create an instance of {@link FblockDataDefinition }
     * @return FblockDataDefinition
     */
    public FblockDataDefinition createFblockDataDefinition() {
        return new FblockDataDefinition();
    }

    /**
     * Create an instance of {@link ContinueStatement }
     * @return ContinueStatement
     */
    public ContinueStatement createContinueStatement() {
        return new ContinueStatement();
    }

    /**
     * Create an instance of {@link FdoWhileStatement }
     * @return FdoWhileStatement
     */
    public FdoWhileStatement createFdoWhileStatement() {
        return new FdoWhileStatement();
    }

    /**
     * Create an instance of {@link Condition }
     * @return Condition
     */
    public Condition createCondition() {
        return new Condition();
    }

    /**
     * Create an instance of {@link Kind }
     * @return Kind
     */
    public Kind createKind() {
        return new Kind();
    }

    /**
     * Create an instance of {@link FstopStatement }
     * @return FstopStatement
     */
    public FstopStatement createFstopStatement() {
        return new FstopStatement();
    }

    /**
     * Create an instance of {@link FmoduleDefinition }
     * @return FmoduleDefinition
     */
    public FmoduleDefinition createFmoduleDefinition() {
        return new FmoduleDefinition();
    }

    /**
     * Create an instance of {@link FformatDecl }
     * @return FformatDecl
     */
    public FformatDecl createFformatDecl() {
        return new FformatDecl();
    }

    /**
     * Create an instance of {@link FfunctionDefinition }
     * @return FfunctionDefinition
     */
    public FfunctionDefinition createFfunctionDefinition() {
        return new FfunctionDefinition();
    }

    /**
     * Create an instance of {@link FrewindStatement }
     * @return FrewindStatement
     */
    public FrewindStatement createFrewindStatement() {
        return new FrewindStatement();
    }

    /**
     * Create an instance of {@link MinusExpr }
     * @return MinusExpr
     */
    public MinusExpr createMinusExpr() {
        return new MinusExpr();
    }

    /**
     * Create an instance of {@link UnaryMinusExpr }
     * @return UnaryMinusExpr
     */ 
    public UnaryMinusExpr createUnaryMinusExpr() {
        return new UnaryMinusExpr();
    }

    /**
     * Create an instance of {@link Step }
     * @return Step
     */
    public Step createStep() {
        return new Step();
    }

    /**
     * Create an instance of {@link LogLTExpr }
     * @return LogLTExpr
     */
    public LogLTExpr createLogLTExpr() {
        return new LogLTExpr();
    }

    /**
     * Create an instance of {@link Name }
     * @return Name
     */
    public Name createName() {
        return new Name();
    }

    /**
     * Create an instance of {@link DivExpr }
     * @return DivExpr
     */
    public DivExpr createDivExpr() {
        return new DivExpr();
    }

    /**
     * Create an instance of {@link Params }
     * @return Params
     */
    public Params createParams() {
        return new Params();
    }

    /**
     * Create an instance of {@link CoShape }
     * @return CoShape
     */
    public CoShape createCoShape() {
        return new CoShape();
    }

    /**
     * Create an instance of {@link FintConstant }
     * @return FintConstant
     */
    public FintConstant createFintConstant() {
        return new FintConstant();
    }

    /**
     * Create an instance of {@link UpperBound }
     * @return UpperBound
     */
    public UpperBound createUpperBound() {
        return new UpperBound();
    }

    /**
     * Create an instance of {@link Body }
     * @return Body
     */
    public Body createBody() {
        return new Body();
    }

    /**
     * Create an instance of {@link FuseDecl }
     * @return FuseDecl
     */
    public FuseDecl createFuseDecl() {
        return new FuseDecl();
    }

    /**
     * Create an instance of {@link FmoduleProcedureDecl }
     * @return FmoduleProcedureDecl
     */
    public FmoduleProcedureDecl createFmoduleProcedureDecl() {
        return new FmoduleProcedureDecl();
    }

    /**
     * Create an instance of {@link FcontainsStatement }
     * @return FcontainsStatement
     */
    public FcontainsStatement createFcontainsStatement() {
        return new FcontainsStatement();
    }

    /**
     * Create an instance of {@link FfunctionDecl }
     * @return FfunctionDecl
     */
    public FfunctionDecl createFfunctionDecl() {
        return new FfunctionDecl();
    }

    /**
     * Create an instance of {@link LogOrExpr }
     * @return  LogOrExpr
     */
    public LogOrExpr createLogOrExpr() {
        return new LogOrExpr();
    }

    /**
     * Create an instance of {@link FbackspaceStatement }
     * @return FbackspaceStatement
     */
    public FbackspaceStatement createFbackspaceStatement() {
        return new FbackspaceStatement();
    }

    /**
     * Create an instance of {@link FcoArrayRef }
     * @return FcoArrayRef
     */
    public FcoArrayRef createFcoArrayRef() {
        return new FcoArrayRef();
    }

    /**
     * Create an instance of {@link UserBinaryExpr }
     * @return UserBinaryExpr
     */
    public UserBinaryExpr createUserBinaryExpr() {
        return new UserBinaryExpr();
    }

    /**
     * Create an instance of {@link DefModelBinaryOperation }
     * @return DefModelBinaryOperation
     */
    public DefModelBinaryOperation createDefModelBinaryOperation() {
        return new DefModelBinaryOperation();
    }

    /**
     * Create an instance of {@link ArrayIndex }
     * @return ArrayIndex
     */
    public ArrayIndex createArrayIndex() {
        return new ArrayIndex();
    }

    /**
     * Create an instance of {@link FstructDecl }
     * @return FstructDecl
     */
    public FstructDecl createFstructDecl() {
        return new FstructDecl();
    }

    /**
     * Create an instance of {@link FcycleStatement }
     * @return FcycleStatement
     */
    public FcycleStatement createFcycleStatement() {
        return new FcycleStatement();
    }

    /**
     * Create an instance of {@link FcaseLabel }
     * @return FcaseLabel
     */
    public FcaseLabel createFcaseLabel() {
        return new FcaseLabel();
    }

    /**
     * Create an instance of {@link FassignStatement }
     * @return FassignStatement
     */
    public FassignStatement createFassignStatement() {
        return new FassignStatement();
    }

    /**
     * Create an instance of {@link FendFileStatement }
     * @return FendFileStatement
     */
    public FendFileStatement createFendFileStatement() {
        return new FendFileStatement();
    }

    /**
     * Create an instance of {@link VarRef }
     * @return VarRef
     */
    public VarRef createVarRef() {
        return new VarRef();
    }

    /**
     * Create an instance of {@link FstructConstructor }
     * @return FstructConstructor
     */
    public FstructConstructor createFstructConstructor() {
        return new FstructConstructor();
    }

    /**
     * Create an instance of {@link FfunctionType }
     * @return FfunctionType
     */
    public FfunctionType createFfunctionType() {
        return new FfunctionType();
    }

    /**
     * Create an instance of {@link FunctionCall }
     * @return FunctionCall
     */
    public FunctionCall createFunctionCall() {
        return new FunctionCall();
    }

    /**
     * Create an instance of {@link FreadStatement }
     * @return FreadStatement
     */
    public FreadStatement createFreadStatement() {
        return new FreadStatement();
    }

    /**
     * Create an instance of {@link DefModelUnaryOperation }
     * @return DefModelUnaryOperation
     */
    public DefModelUnaryOperation createDefModelUnaryOperation() {
        return new DefModelUnaryOperation();
    }

    /**
     * Create an instance of {@link Ffunction }
     * @return Ffunction
     */
    public Ffunction createFfunction() {
        return new Ffunction();
    }

    /**
     * Create an instance of {@link IndexRange }
     * @return IndexRange
     */
    public IndexRange createIndexRange() {
        return new IndexRange();
    }

    /**
     * Create an instance of {@link FpointerAssignStatement }
     * @return FpointerAssignStatement
     */
    public FpointerAssignStatement createFpointerAssignStatement() {
        return new FpointerAssignStatement();
    }

    /**
     * Create an instance of {@link UserUnaryExpr }
     * @return UserUnaryExpr
     */
    public UserUnaryExpr createUserUnaryExpr() {
        return new UserUnaryExpr();
    }

    /**
     * Create an instance of {@link Len }
     * @return Len
     */
    public Len createLen() {
        return new Len();
    }

    /**
     * Create an instance of {@link FcharacterConstant }
     * @return FcharacterConstant
     */
    public FcharacterConstant createFcharacterConstant() {
        return new FcharacterConstant();
    }

    /**
     * Create an instance of {@link VarList }
     * @return VarList
     */
    public VarList createVarList() {
        return new VarList();
    }

    /**
     * Create an instance of {@link Then }
     * @return Then
     */
    public Then createThen() {
        return new Then();
    }

    /**
     * Create an instance of {@link ExprStatement }
     * @return ExprStatement
     */
    public ExprStatement createExprStatement() {
        return new ExprStatement();
    }

    /**
     * Create an instance of {@link StatementLabel }
     * @return StatementLabel
     */
    public StatementLabel createStatementLabel() {
        return new StatementLabel();
    }

    /**
     * Create an instance of {@link FpauseStatement }
     * @return FpauseStatement
     */
    public FpauseStatement createFpauseStatement() {
        return new FpauseStatement();
    }

    /**
     * Create an instance of {@link LogNotExpr }
     * @return LogNotExpr
     */
    public LogNotExpr createLogNotExpr() {
        return new LogNotExpr();
    }

    /**
     * Create an instance of {@link FrealConstant }
     * @return FrealConstant
     */
    public FrealConstant createFrealConstant() {
        return new FrealConstant();
    }

    /**
     * Create an instance of {@link FcommonDecl }
     * @return FcommonDecl
     */
    public FcommonDecl createFcommonDecl() {
        return new FcommonDecl();
    }

    /**
     * Create an instance of {@link LogLEExpr }
     * @return LogLEExpr
     */
    public LogLEExpr createLogLEExpr() {
        return new LogLEExpr();
    }

    /**
     * Create an instance of {@link NamedValueList }
     * @return NamedValueList
     */
    public NamedValueList createNamedValueList() {
        return new NamedValueList();
    }

    /**
     * Create an instance of {@link FlogicalConstant }
     * @return FlogicalConstant
     */
    public FlogicalConstant createFlogicalConstant() {
        return new FlogicalConstant();
    }

    /**
     * Create an instance of {@link FentryDecl }
     * @return FentryDecl
     */
    public FentryDecl createFentryDecl() {
        return new FentryDecl();
    }

    /**
     * Create an instance of {@link Value }
     * @return Value
     */
    public Value createValue() {
        return new Value();
    }

    /**
     * Create an instance of {@link RepeatCount }
     * @return RepeatCount
     */
    public RepeatCount createRepeatCount() {
        return new RepeatCount();
    }

    /**
     * Create an instance of {@link LogEQVExpr }
     * @return LogEQVExpr
     */
    public LogEQVExpr createLogEQVExpr() {
        return new LogEQVExpr();
    }

    /**
     * Create an instance of {@link FdataDecl }
     * @return FdataDecl
     */
    public FdataDecl createFdataDecl() {
        return new FdataDecl();
    }

    /**
     * Create an instance of {@link TypeTable }
     * @return TypeTable
     */
    public TypeTable createTypeTable() {
        return new TypeTable();
    }

    /**
     * Create an instance of {@link FcloseStatement }
     * @return FcloseStatement
     */
    public FcloseStatement createFcloseStatement() {
        return new FcloseStatement();
    }

    /**
     * Create an instance of {@link GlobalSymbols }
     * @return GlobalSymbols
     */
    public GlobalSymbols createGlobalSymbols() {
        return new GlobalSymbols();
    }

    /**
     * Create an instance of {@link FwriteStatement }
     * @return FwriteStatement
     */
    public FwriteStatement createFwriteStatement() {
        return new FwriteStatement();
    }

    /**
     * Create an instance of {@link Renamable }
     * @return Renamable
     */
    public Renamable createRenamable() {
        return new Renamable();
    }

    /**
     * Create an instance of {@link XcodeProgram }
     * @return XcodeProgram
     */
    public XcodeProgram createXcodeProgram() {
        return new XcodeProgram();
    }

    /**
     * Create an instance of {@link FnamelistDecl }
     * @return FnamelistDecl
     */
    public FnamelistDecl createFnamelistDecl() {
        return new FnamelistDecl();
    }

    /**
     * Create an instance of {@link Text }
     * @return Text
     */
    public Text createText() {
        return new Text();
    }

    /**
     * Create an instance of {@link LogGEExpr }
     * @return LogGEExpr
     */
    public LogGEExpr createLogGEExpr() {
        return new LogGEExpr();
    }

    /**
     * Create an instance of {@link FnullifyStatement }
     * @return FnullifyStatement
     */
    public FnullifyStatement createFnullifyStatement() {
        return new FnullifyStatement();
    }

    /**
     * Create an instance of {@link FarrayConstructor }
     * @return FarrayConstructor
     */
    public FarrayConstructor createFarrayConstructor() {
        return new FarrayConstructor();
    }

    /**
     * Create an instance of {@link GlobalDeclarations }
     * @return GlobalDeclarations
     */
    public GlobalDeclarations createGlobalDeclarations() {
        return new GlobalDeclarations();
    }

    /**
     * Create an instance of {@link LogNEQVExpr }
     * @return LogNEQVExpr
     */
    public LogNEQVExpr createLogNEQVExpr() {
        return new LogNEQVExpr();
    }

    /**
     * Create an instance of {@link GotoStatement }
     * @return GotoStatement
     */
    public GotoStatement createGotoStatement() {
        return new GotoStatement();
    }

    /**
     * Create an instance of {@link LowerBound }
     * @return LowerBound
     */
    public LowerBound createLowerBound() {
        return new LowerBound();
    }

    /**
     * Create an instance of {@link FconcatExpr }
     * @return FconcatExpr
     */
    public FconcatExpr createFconcatExpr() {
        return new FconcatExpr();
    }

    /**
     * Create an instance of {@link FcomplexConstant }
     * @return FcomplexConstant
     */
    public FcomplexConstant createFcomplexConstant() {
        return new FcomplexConstant();
    }

    /**
     * Create an instance of {@link FmemberRef }
     * @return FmemberRef
     */
    public FmemberRef createFmemberRef() {
        return new FmemberRef();
    }

    /**
     * Create an instance of {@link PlusExpr }
     * @return PlusExpr
     */
    public PlusExpr createPlusExpr() {
        return new PlusExpr();
    }

    /**
     * Create an instance of {@link FinterfaceDecl }
     * @return FinterfaceDecl
     */
    public FinterfaceDecl createFinterfaceDecl() {
        return new FinterfaceDecl();
    }

    /**
     * Create an instance of {@link FreturnStatement }
     * @return FreturnStatement
     */
    public FreturnStatement createFreturnStatement() {
        return new FreturnStatement();
    }

    /**
     * Create an instance of {@link Alloc }
     * @return Alloc
     */
    public Alloc createAlloc() {
        return new Alloc();
    }

    /**
     * Create an instance of {@link LogAndExpr }
     * @return LogAndExpr
     */
    public LogAndExpr createLogAndExpr() {
        return new LogAndExpr();
    }

    /**
     * Create an instance of {@link MulExpr }
     * @return MulExpr
     */
    public MulExpr createMulExpr() {
        return new MulExpr();
    }

    /**
     * Create an instance of {@link FpragmaStatement }
     * @return FpragmaStatement
     */
    public FpragmaStatement createFpragmaStatement() {
        return new FpragmaStatement();
    }

    /**
     * Create an instance of {@link FinquireStatement }
     * @return FinquireStatement
     */
    public FinquireStatement createFinquireStatement() {
        return new FinquireStatement();
    }

    /**
     * Create an instance of {@link Symbols }
     * @return Symbols
     */
    public Symbols createSymbols() {
        return new Symbols();
    }

}
